local HunterPetXPFrame = CreateFrame("Frame")

HunterPetXPFrame:RegisterEvent("ADDON_LOADED")
HunterPetXPFrame:RegisterEvent("PLAYER_XP_UPDATE")
HunterPetXPFrame:RegisterEvent("PLAYER_LEVEL_UP")
HunterPetXPFrame:RegisterEvent("UPDATE_EXHAUSTION")
HunterPetXPFrame:RegisterEvent("UNIT_PET")
HunterPetXPFrame:RegisterEvent("UNIT_PET_EXPERIENCE")
HunterPetXPFrame:RegisterEvent("ZONE_CHANGED")
HunterPetXPFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
HunterPetXPFrame:RegisterEvent("PLAYER_CONTROL_LOST")
HunterPetXPFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
HunterPetXPFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
HunterPetXPFrame:RegisterEvent("CINEMATIC_START")
HunterPetXPFrame:RegisterEvent("CINEMATIC_STOP")

--oldPetXP, oldNextPetXP = GetPetExperience()
--oldPetLevel = UnitLevel("pet")

HunterPetXPFrame:SetScript("OnEvent",

function(self,event,...)
	if event == "UNIT_PET" then
		oldPetXP, oldNextPetXP = GetPetExperience()
		oldPetLevel = UnitLevel("pet")
		--print (oldPetXP .. ' ' .. oldNextPetXP .. ' ' .. oldPetLevel)
	elseif event == "UNIT_PET_EXPERIENCE" then
		petName = UnitName("pet")
		petLevel = UnitLevel("pet")
		currentPetXP, nextPetXP = GetPetExperience()
		PetXPtoLevel = nextPetXP - currentPetXP
		--print (oldPetXP .. ' ' .. oldPetLevel .. ' ' .. currentPetXP .. ' ' .. oldNextPetXP)
	
		if petLevel>oldPetLevel then
			XPDifference = oldNextPetXP - oldPetXP + currentPetXP
			oldPetLevel = petLevel
			oldNextPetXP = nextPetXP
			print('Congrats! ' .. petName .. ' has reached level ' .. petLevel .. '!')
		else
			XPDifference = currentPetXP - oldPetXP
			oldPetXP = currentPetXP
		end
	
		KillsLeft = math.ceil(PetXPtoLevel/XPDifference)
		PetPercentage = math.floor(((currentPetXP/nextPetXP))*100)
	
		if KillsLeft > 0 then
			print(KillsLeft .. ' kills of that level until ' .. petName .. ' reaches level ' .. petLevel+1)
			print('Currently ' .. currentPetXP .. '/' .. nextPetXP .. 'xp (' .. PetPercentage .. '%)(+' .. XPDifference .. ')')
		end
	else
		--print(event)
	end
end)